/*
 * Pair.h
 *
 *  Created on: Oct 7, 2008
 *      Author: bloch
 */

#ifndef PAIR_H_
#define PAIR_H_

#include <iostream>

class Pair {
public:
	int x, y;
	Pair(int xarg, int yarg); // ordinary constructor
	// I haven't written 
	// Pair();	default constructor
	// Compiler would have provided that if I hadn't written ANY
	// constructor, just as in Java

	// I haven't written
	// Pair(const &Pair);	copy constructor 
	// const Pair & operator=(const Pair &source); assignment operator 
	// ~Pair();		destructor
	// The compiler has provided these three automatically.

	int getX() const { return x; }
	int getY() const { return y; }
};

#endif /* PAIR_H_ */
