/*
 * mainprog.cpp
 *
 *  Created on: Oct 28, 2009
 *      Author: bloch
 */

#include <iostream>
#include "Pair.h"
using std::cout;
using std::endl;

Pair doSomething (Pair p) {
	return Pair(p.getY(), p.getX());
	}
	
int main () {
	const Pair origin;
	Pair here(3,4);
	Pair there(5,-12);
	Pair thereAgain(5, -12);
	Pair thereYetAgain = there; // calls copy constructor
	Pair *elsewhere = new Pair(8, 6);

	cout << here.getX() << " should be 3" << endl;
	cout << there.getY() << " should be -12" << endl;

	{
		Pair result = doSomething(there);
		// calls copy constructor twice: once to copy "there" into
		// doSomething's parameter, and once to copy return value into
		// "result".
	
		cout << result.getX() << " should be -12" << endl;
		cout << result.getY() << " should be 5" << endl;
	
		result = there; // calls overloaded = operator
		cout << result.getX() << " should be 5" << endl;
		cout << result.getY() << " should be -12" << endl;
	}
	cout << "So much for result; let's go on." << endl;

	cout << origin << " should be (0, 0)" << endl;
	cout << here << " should be (3, 4)" << endl;
	cout << *elsewhere << " should be (8, 6)" << endl;

//	here += there;

//	cout << here << " should be (8, -8)" << endl;

	cout << (there == there) << " should be true " << endl;
	cout << (there == thereAgain) << " should be true " << endl;
	cout << (there == here) << " should be false" << endl;
	cout << (here == origin) << " should be false" << endl;
	cout << (origin == here) << " should be false" << endl;
//	cout << (there != there) << " should be false" << endl;
//	cout << (there != thereAgain) << " should be false" << endl;
//	cout << (there != here) << " should be true" << endl;

	return 0;
}
