/*
 * Pair.h
 *
 *  Created on: Oct 7, 2008
 *      Author: bloch
 */

#ifndef PAIR_H_
#define PAIR_H_

#include <iostream>
using std::cerr;
using std::endl;

class Pair {
public:
	int x, y;
	Pair(int xarg=0, int yarg=0) : x(xarg), y(yarg) {
		x = xarg;
		y = yarg;
		cerr << "Constructing Pair(" << xarg << "," << yarg << ")" << endl;
		}
	// Since this now allows 0, 1, or 2 arguments, it counts as a
	// default constructor.

	Pair(const Pair & old);	// copy constructor 
	const Pair & operator=(const Pair &source); // assignment operator 
	~Pair();		// destructor

	int getX() const { return x; }
	int getY() const { return y; }
};

// const Pair &operator= (Pair &dest, const Pair &source);
// Turns out the assignment operator CAN'T be a stand-alone function;
// it HAS to be a member function.
#endif /* PAIR_H_ */
