/*
 * Pair.h
 *
 *  Created on: Oct 7, 2008
 *      Author: bloch
 */

#ifndef PAIR_H_
#define PAIR_H_

#include <iostream>
using std::cerr;
using std::endl;

class Pair {
public: // Try making this private.  What happens?
	int x, y;
public:
	Pair(int xarg=0, int yarg=0) : x(xarg), y(yarg) {
		x = xarg;
		y = yarg;
		cerr << "Constructing Pair(" << xarg << "," << yarg << ")" << endl;
		}
	// Since this now allows 0, 1, or 2 arguments, it counts as a
	// default constructor.

	Pair(const Pair & old);	// copy constructor 
	const Pair & operator=(const Pair &source); // assignment operator 
	~Pair();		// destructor

	int getX() const { return x; }
	int getY() const { return y; }
};

bool operator==(const Pair &left, const Pair &right);
// Try taking out one or both of the "const"s.  What happens?
#endif /* PAIR_H_ */
